找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 789|回复: 0

[分享] Create ordinate dimension

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 03:18:45 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
       [CommandMethod("CreateOrdinateDimension","cdom", CommandFlags.Modal | CommandFlags.UsePickSet)]
        public static void testOrdinateDimension()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Editor ed = doc.Editor;
            Database db = doc.Database;
            ObjectId id = ObjectId.Null;
            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                PromptPointOptions ppo = new PromptPointOptions("\n  >>  Select point for ordinate dimension >>");

                PromptPointResult ppr = ed.GetPoint(ppo);

                if (ppr.Status != PromptStatus.OK) return;

                double gap = db.Dimtxt * 2;

               Point3d  pt = ppr.Value;

               Point3d tpt = new Point3d(pt.X, pt.Y + gap, pt.Z);

               Matrix3d mx = ed.CurrentUserCoordinateSystem.Inverse();

               Vector3d mXPrev = Vector3d.XAxis;
                // build custom dimension text
               string dstr = string.Format("X = {0:f3}\\PY = {1:f3}", pt.X, pt.Y);// set precision to 3 decimals {:f3}

               OrdinateDimension odim = new OrdinateDimension(false, pt, tpt, dstr, db.Dimstyle);

               double ohrot = odim.HorizontalRotation;
               // get the old Xaxis and transform it to current plane
               Matrix3d mMat = Matrix3d.PlaneToWorld(odim.Normal); //ECS

               mXPrev.TransformBy(mMat); //get the ECS xaxis in the world coordinates

               mXPrev.TransformBy(mx); //transform current xaxis to plane defined by mx

               // transform the dimension entity by the given transformation matrix

               odim.TransformBy(mx);

               // get the xAxis after transformation of the dimension entity

               mMat=   Matrix3d.WorldToPlane(odim.Normal);

               // transform the old axis to the current ECS.

               mXPrev.TransformBy(mMat);

                  // get the angle of the old xaxis with respect to the current xaxis
               
                 double newhrot = - Math.Atan2(mXPrev.X, mXPrev.Y);

                 odim.HorizontalRotation = ohrot + newhrot;

               postToModelSpace(odim);

               tr.AddNewlyCreatedDBObject(odim, true);
   
                    tr.Commit();
                }
            }


        static void postToModelSpace(Entity ent)
        {

            BlockTableRecord btr;

            Database db = HostApplicationServices.WorkingDatabase;

            btr = SymbolUtilityServices.GetBlockModelSpaceId(db).GetObject(OpenMode.ForWrite) as BlockTableRecord;

            btr.AppendEntity(ent);

        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-22 12:40 , Processed in 0.234307 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表